#!python
import sys
import daemon
from argparse import ArgumentParser
from subprocess import call


def server():
	parser = ArgumentParser(
		description="Simple development server for WeefPy framework"
	)
	parser.add_argument('--daemon', action="store_true", help="Run server as daemon")
	parser.add_argument('--config', nargs=1, default=[""], help="Path to uwsgi.ini config file")
	parser.add_argument('--pythonpath', nargs=1, default=["."], help="Provided pythonpath")
	parser.add_argument('--host', nargs=1, default=[None], help="Server IP address")
	parser.add_argument('--port', nargs=1, default=[None], help="Server port")
	parser.add_argument(
		'--app', nargs=1, default=[None],
		help="Callable application in format file:app - where app is callable object"
	)
	args = parser.parse_args(sys.argv[1:])
	config = args.config[0]
	pythonpath = args.pythonpath[0]
	host = args.host[0]
	port = args.port[0]
	app = args.app[0]
	command = "uwsgi %s --pythonpath %s --py-autoreload 1" % (config, pythonpath)
	if port:
		if not host:
			host = "127.0.0.1"
		command += " --http %s:%s" % (host, port)
	elif host:
		port = "8080"
		command += " --http %s:%s" % (host, port)
	if app:
		file, app = (*app.split(":"),)
		command += " --wsgi-file %s" % file
		if app:
			command += " --callable %s" % app
	if args.daemon:
		with daemon.DaemonContext():
			call(command, shell=True)
	else:
		call(command, shell=True)
