from re import Pattern


class Route:
	_routes = {}
	_reg_routes = []

	def __init__(self, route, methods=[], method="GET", auth_required=False):
		self._route = None
		self._auth_required = auth_required
		if type(route) == str:
			if route[0] != "/":
				raise Exception("Route must start with '/'! (%s)" % route)
			self._route = route if route[-1] == ("/") else route + "/"
		elif type(route) == Pattern:
			self._route = route
		else:
			raise Exception("Route must be str or re.Pattern type! (%s, %s)" % (route, str(type(route))))
		self._methods = methods if len(methods) else [method or "GET"]

	def __call__(self, fce, *args):
		if type(self._route) == Pattern:
			self._reg_routes.append((self._route, fce, self._methods, self._auth_required))
		elif self._route:
			for method in self._methods:
				if self._route not in self._routes:
					self._routes[self._route] = {}
				elif method in self._routes[self._route]:
					raise Exception("Route alreay set! (%s - %s)" % self._routes.get(method, self._route))
				self._routes[self._route][method] = (fce, self._auth_required)

	@staticmethod
	def get(path, method):
		route = Route._routes.get(path if path[-1] == "/" else path + "/", {})
		if result := route.get(method, False):
			return result[0], (), None, result[1]
		else:
			for item in Route._reg_routes:
				if match := item[0].match(path):
					route = True
					if method in item[2]:
						return item[1], match.groups(0), None, item[3]
		if route and not result:
			return None, (), True, False
		return None, (), False, False
